/******************************************************************
Module : Driver.h - Common header for the driver and application
                     Defines device name, IOCTL codes, etc.
             Written 1998,1999 by Dmitri Leman
Purpose: Purpose: NT kernel mode tracer.
******************************************************************/

#ifndef _DRIVER_H_
#define _DRIVER_H_

#define TRACER_KERNEL_DEVICE_NAME L"\\Device\\Tracer"
#define TRACER_DOS_DEVICE_NAME_A  "\\DosDevices\\Tracer"
#define TRACER_DOS_DEVICE_NAME_W  L"\\DosDevices\\Tracer"

#define TRACER_WIN32_FILE_NAME_W    L"\\\\.\\Tracer"
#define TRACER_WIN32_FILE_NAME_A    "\\\\.\\Tracer"

#define TRACER_REG_CONFIG_PATH_W    L"CookedConfigPath"
#define TRACER_REG_CONFIG_PATH_A     "CookedConfigPath"

//Define a random device type and IOCTL codes, which will be used 
//by our launcher application to call our driver
#define FILE_DEVICE_TRACER     0x83ff

#define IOCTL_TRACER_CHECK_ACTIVE ((ULONG) CTL_CODE\
    ( FILE_DEVICE_TRACER, 0x01, METHOD_BUFFERED, FILE_ANY_ACCESS ))
#define IOCTL_TRACER_DUMP_TRACE   ((ULONG) CTL_CODE\
    ( FILE_DEVICE_TRACER, 0x02, METHOD_BUFFERED, FILE_ANY_ACCESS ))


#endif//#define _DRIVER_H_