/******************************************************************
Module : EnumMods.h Class EnumModules to enumerate loaded modules 
                    in NT kernel mode
             Written 1998,1999 by Dmitri Leman
Purpose: NT kernel mode tracer.
******************************************************************/

#ifndef _ENUMMODS_H_
#define _ENUMMODS_H_


#pragma pack(push,4)

class EnumModules
{
public:
    EnumModules() {vCleanup();}
    ~EnumModules() {vFree();}

    struct DriverInfo
    {
        ULONG m_ulAddress;
        ULONG m_ulUnknown1;
        ULONG m_ulUnknown2;
        ULONG m_ulIndex;
        ULONG m_ulUnknown3;
        char  m_szName[_MAX_PATH + 1];
    };//struct DriverInfo

    void vFree();
    
    const DriverInfo * pGetFirst();
    const DriverInfo * pGetNext();
    long lGetIndex() const { return m_lCurIndex;}

    ULONG GetModuleHandle(const char * p_pszModuleName);

    bool bLoadInfo(bool p_bForceReload);
private:
    void vCleanup();

    ULONG m_ulNumBytes;
    ULONG m_ulNumEntries;
    ULONG * m_pulBuffer;

    DriverInfo * m_pDriverInfo;
    LONG  m_lCurIndex;
};//class EnumModules

#pragma pack(pop)

#endif //_ENUMMODS_H_