/******************************************************************
Module : FileSupp.cpp    - wrapper around file API
             Written 1998,1999 by Dmitri Leman
Purpose: NT kernel mode tracer.
******************************************************************/

#ifndef _FILESUPP_H_
#define _FILESUPP_H_

#pragma pack(push,4)

class MyFileImpl
{
public:
    void Cleanup();
    
    ULONG OpenFile(const char * p_pszFileName, bool  p_bWrite,
        bool p_bPrependQuestionMarks,
        #if defined(_DRIVER)
            PUNICODE_STRING p_FileName
        #else
            void *
        #endif
        );

    ULONG CloseFile();

    ULONG GetFileSize(OUT PLARGE_INTEGER  p_pReturnSize);

    ULONG ReadWriteFile(IN bool p_bWrite, 
        OUT     void *  p_lpBuffer,
        IN      ULONG   p_dwNumberOfBytes,
        IN  OUT PLARGE_INTEGER p_pByteOffset,
        OUT     ULONG*  p_pdwNumberOfBytesProcessed);

    ULONG FlushBuffers();
protected:
    HANDLE  m_hFileHandle;
};//class MyFileImpl

class MyFileLocal : public MyFileImpl
{
public:
    MyFileLocal(){Cleanup();}
    ~MyFileLocal() {CloseFile();}
};//class MyFileLocal : public MyFileImpl

#pragma pack(pop)

#endif //_FILESUPP_H_