/******************************************************************
Module : InstDrv.h  - InstallDriver class to register/unregister,
            start and stop drivers
         Written 1998,1999 by Dmitri Leman
Purpose: Purpose: NT kernel mode tracer.
******************************************************************/

class InstallDriver
{
public:
    static bool bRegisterDeviceDriver(
        IN LPCTSTR p_pszDriverName,
        IN LPCTSTR p_pszDriverPath);

    static bool bRegisterDeviceDriver(
        IN SC_HANDLE  p_hSchSCManager,
        IN LPCTSTR    p_pszDriverName,
        IN LPCTSTR    p_pszDriverPath);

    static bool bStartDriver(
        IN SC_HANDLE  p_hSchSCManager,
        IN LPCTSTR    p_pszDriverName);

    static bool bStartDriverAndOpenDevice(
        IN LPCTSTR p_pszName, 
        IN LPCTSTR p_pszDeviceName, 
        OUT HANDLE * p_phDevice );

    static bool bUnloadDeviceDriver(
        IN LPCTSTR p_pszName, 
        IN bool p_bUnregister);



    static bool bOpenDevice(
        IN  LPCTSTR  p_pszDeviceName, 
        OUT HANDLE * lphDevice);

    static bool bStopDriver(
        IN SC_HANDLE  p_pszSchSCManager,
        IN LPCTSTR    p_pszDriverName);

    static bool bRemoveDriver(
        IN SC_HANDLE  p_pszSchSCManager,
        IN LPCTSTR    p_pszDriverName);

};//class InstallDriver

