/*****************************************************************
Module : Intrcpt.h    - few functions which performs interception
                        business gathered into Interceptor class
             Written 1998,1999 by Dmitri Leman
Purpose: NT kernel mode tracer.
******************************************************************/
#ifndef _INTRCPT_H_
#define _INTRCPT_H_

struct ASM_APIFunctionStub;
class Interceptor
{
public:
    static ASM_APIFunctionStub * IsItInterceptedFunction
    (
        void * p_pAddress
    );

    static bool bInterceptVTableFunction
    (
        ASM_APIFunctionStub  * p_pStub,
        void                 * p_pVTable,
        int                    p_iIndexOfFunction//non-negative
    );

    static bool bProcPInterface
    (
        ULONG   p_dwPointerToPIUnknown,
        int     p_iInterfaceIndex,
        ULONG * p_rdwReturnedPIUnknown,
        ULONG * p_rdwReturnedVTBL,
        char  * p_pszReturnInterfaceName,
        int     p_iInterfaceBufferSize
    );

    static int iInterceptImportedFunctionsInModule
    (
        PVOID p_pModuleBaseAddress,
        PCSTR p_pszFileName,
        bool  p_bRestore,
        bool  p_bUseFile
    );

    static bool bProcessExportsForOneModule
        (MyInterface & p_rInt, bool p_bUnhook);
    static int iProcessExportForOneModuleAndOneStub
        (PVOID p_pNTHeader,
        MyInterface &   p_rInt, ASM_APIFunctionStub &   p_rStub,
        bool p_bUnhook);
    static MyInterface * pFindModuleByName(const char * p_pszName);
    static bool bHookAllModules(bool  p_bRestore);
    static bool bHookAllModulesImpl
        (EnumModules & p_rEnum, bool p_bRestore);

};//class Interceptor
#endif //_INTRCPT_H_
