/******************************************************************
Module : KrnlTrc.h        Common header for the EXE and the driver.
             Written 1998,1999 by Dmitri Leman
Purpose: NT kernel mode tracer.
*******************************************************************/

#ifndef _KRNLTRC_H_
#define _KRNLTRC_H_

#pragma pack(push,4)

#ifndef offsetof
#define offsetof(s,m)   (size_t)&(((s *)0)->m)
#endif

/*
struct KrnlTrcParams is used to pass data from EXE to spy driver
in a binary cinfiguration file
*/
struct KrnlTrcParams 
{
    ULONG   m_dwParamSize;//size of this structure + attached config
    bool    m_bPerformInterception;
    char    m_szDriverName[_MAX_PATH];
    char    m_szDriverPath[_MAX_PATH];
    char    m_szDeviceName[_MAX_PATH];
    char    m_szConfigFileName[_MAX_PATH];
    
    char    m_szConfigOutFileName[_MAX_PATH];      
        //Where to store binary config file

    char    m_szConfigOutFileNameDriver[_MAX_PATH];
        //Same as m_szConfigOutFileName, but with "\??\" prefix

    char    m_szLogFileName[_MAX_PATH];

    //The following names and pathes are used to contruct pathes to
    //modules for the interception
    char    m_szWindowsDir[_MAX_PATH];
    int     m_iLengthWindowsDir;
    char    m_szDriversDir[_MAX_PATH];
    int     m_iLengthDriversDir;

    ULONG   m_dwOutputDebugStringMask;
    ULONG   m_dwTraceBufferMask;
    int     m_iTraceBufferSize;

    bool    m_bPrintParams;
    int     m_iLimitStringOutput;//maximum number of chars to print
    bool    m_bPrintThreadId;
    bool    m_bPrintProcessorNumber;
    bool    m_bPrintIRQL;
    ULONG   m_dwOffsetCfgData;//offset from the beginning of this 
        //structure of memory area where preprocessed configuration
        //data are stored
    bool    m_bInterceptReturns;
    int     m_iNumReturnStubs;//how many stubs for storing return 
                              //addresses to allocate
    bool    m_bDontFreeStubMemory;//leave the array of stubs in the
            //non-paged memory after termination of the driver.
            //Useful if the system crashes after the tracer unload
};//struct KrnlTrcParams

#pragma pack(pop)

#endif//#ifndef _KRNLTRC_H_
