/******************************************************************
Module : KrnlTrcD.h Declaration of global structures for the driver
             Written 1998,1999 by Dmitri Leman
Purpose: NT kernel mode tracer.
******************************************************************/

#ifndef _KRNLTRCD_H_
#define _KRNLTRCD_H_

#pragma pack(push,4)

#pragma intrinsic(memset,memcpy,strlen,strcpy)

struct KrnlTrcParams;
class  StubManager;
class  RefCountChecker;
class  ReturnMgr;

class EnumModules;
struct SpyGlobalData
{
public:
    NTSTATUS KrnlTrcDriverInit(
        IN  PUNICODE_STRING p_pRegistryPath);
    void ShutDownKrnlTrcDriver();
    NTSTATUS ReadRegistry(
        IN  PUNICODE_STRING p_pRegistryPath,
        OUT PUNICODE_STRING p_pConfigFilePath);
public:
    bool        m_bSpyInitialized;
    KrnlTrcParams * m_pParams;
    StubManager * m_pConfigMgr;
    ReturnMgr   * m_pRetMgr;

    bool        m_bPrintThreadId;
    bool        m_bPrintProcessorNumber;
    bool        m_bPrintIRQL;
    int         m_iLimitStringOutput;

    PCSTR       m_pszGetProcAddressName;
};//struct SpyGlobalData

extern SpyGlobalData g_Data;

#pragma pack(pop)

#endif//#ifndef _KRNLTRCD_H_
