/******************************************************************
Module : NtImage.h   - header file to allow include of Win32 
        "WinNT.h" in the driver project. This file provides
        declarations of internal structures of PE file format.
        The problem is that it cannot be included in the driver
        directly, because of conflicts with "ntddk.h".
        Therefore, I use namespace to resolve the conflict.
             Written 1998,1999 by Dmitri Leman
Purpose: NT kernel mode tracer.
******************************************************************/

typedef unsigned char BYTE, *PBYTE;
typedef unsigned short WORD, *PWORD;
typedef unsigned long DWORD, *PDWORD;
typedef unsigned long UINT_PTR, *PUINT_PTR;
typedef long INT_PTR, *PINT_PTR;

extern "C"
{

//I need to include Win32 "Winnt.h" to obtain headers describing PE format.
//To avoid collision of many type declarations I will use namespace.
namespace WinNT
{
#undef UInt32x32To64
#undef MAKELANGID
#undef PRIMARYLANGID
#undef SUBLANGID
#undef MAKELCID
#undef LANGIDFROMLCID
#undef SORTIDFROMLCID
#undef FIELD_OFFSET
#undef CONTAINING_RECORD
#undef FILE_ALL_ACCESS

#define WIN32_NO_STATUS

#include "Winnt.h"
}
}
using WinNT::PIMAGE_NT_HEADERS;
using WinNT::PIMAGE_DOS_HEADER;
using WinNT::PIMAGE_EXPORT_DIRECTORY;
using WinNT::IMAGE_IMPORT_DESCRIPTOR;
using WinNT::IMAGE_THUNK_DATA;
using WinNT::PIMAGE_SECTION_HEADER;
using WinNT::IMAGE_NT_HEADERS;
using WinNT::PIMAGE_NT_HEADERS;
