/*****************************************************************
Module : ParseCfg.h  - parser of configuration file
             Written 1998,1999 by Dmitri Leman
Purpose: COM/OLE tracer and NT kernel mode tracer.
******************************************************************/

#ifndef _PARSECFG_H_
#define _PARSECFG_H_

#pragma pack(push,4)

#define MAX_FUNCTION_NAME_LEN      256 
#define MAX_DLL_INTERFACE_NAME_LEN 256

enum FunctionType
{
    FT_None, //no function found
    FT_Export,//a DLL exported function
    FT_InterfaceName,//an interface declaration
    FT_InterfaceFunc,//an interface function declaration
};//enum FunctionType

FunctionType IsNewFunctionOrInterface
(
    PSTR p_pszInputLine
);

enum ParamType;
class AllInterfacesUnderConstruction;
class InterfaceUnderConstruction;
class FunctionUnderConstruction;
class Parser
{
public:
    Parser();
    virtual ~Parser();
    BOOL bLoadConfigFile(char * p_pszConfiFileName);
    int  iGetExportedSize();
    int  iExport(PBYTE p_pMem, int p_iTotalSize, int p_iCurOffset);
    BOOL bGetLogGetProcAddress() {return m_bLogGetProcAddress;}
protected:
    BOOL bAddInterface();
    BOOL bStartFunctionConstruction();
    BOOL bFinishFunctionConstruction();

    BOOL bAddParam(ParamType p_Type, BYTE p_byFlags, 
        BOOL p_bExtraBytePresent, BYTE  p_byExtra);

    BOOL bParseLine(
        PSTR p_pszInputLine,
        FunctionType p_Type
    );

    PCSTR pszGetDLLName(){return m_szDLLorInterfaceName;}
    PCSTR pszGetFuncName(){return m_szFunctionName;}

    BOOL bParseAndAddParam(PSTR pszParam);

    BOOL bGetToken
    (
        PCSTR   p_pszFullLine,
        PCSTR & p_rpszString,
        char    p_cSeparatorChar,
        PSTR    p_pszReturnBuffer,
        int     p_iSizeRetBuffer,
        PCSTR   p_pszTokenNameForDebug
    );
    BOOL bScanFile(FILE * p_pInputFile);

    FunctionType IsNewFunctionOrInterface(PSTR p_pszInputLine);

    BOOL bParseExportedFunction(PCSTR p_pszInputLine);
    BOOL bParseInterfaceFunction(PCSTR p_pszInputLine);
    BOOL bParseInterfaceName(PCSTR p_pszInputLine);
protected:
    AllInterfacesUnderConstruction * m_pAllIntr;

    int                          m_iCurInterface;
    InterfaceUnderConstruction * m_pCurInterface;

    FunctionUnderConstruction  * m_pCurFunction;
    FunctionType m_CurrentFunction;
    char m_szFunctionName[MAX_FUNCTION_NAME_LEN];
    int  m_iFunctionIndex;

    char m_szDLLorInterfaceName[MAX_DLL_INTERFACE_NAME_LEN];
    char m_szBaseInterfaceName[MAX_DLL_INTERFACE_NAME_LEN];
    IID  m_InterfaceID;

    int m_iLineNumber;

    BOOL m_bLogGetProcAddress;
};//class Parser

#pragma pack(pop)

#endif//_PARSECFG_H_
