/******************************************************************
Module : RetStub.h    Declaration of the ReturnStub structure to be
                      used to intercept function's return
             Written 1998,1999 by Dmitri Leman
Purpose: NT kernel mode tracer. Used in the driver project.
******************************************************************/

#ifndef _RETSTUB_H_
#define _RETSTUB_H_

#pragma pack(push,1)

#include "log.h"

#define MAX_OUT_PARAMETERS    5

struct ASM_APIFunctionStub;

struct ReturnStub
{
    ULONG    m_dwReturnAddress;
    UCHAR    m_byReserved[3];
    UCHAR    m_byCallInstruction;
    ULONG    m_dwCallOffset;
    ASM_APIFunctionStub * m_pStub;
    ULONG    m_dwOutParameter[MAX_OUT_PARAMETERS];
    
    //The following members are used inside Logger::IntrerceptEntry
    //and Logger::ProcessReturn. They are not preserved from the
    //entry to the moment of return, as the other members (above).
    //We keep them here to reduce stack usage.
    char     m_szFormattedString[512];
    ParamProcContext m_Context;
};//struct ReturnStub

#pragma pack(pop)

#endif// _RETSTUB_H_