/******************************************************************
Module : Return.h   - handles interception of functions returns
             Written 1998,1999 by Dmitri Leman
Purpose: NT kernel mode tracer
******************************************************************/
#ifndef _RETURN_H_
#define _RETURN_H_

#pragma pack(push,4)

struct ASM_APIFunctionStub;
struct ReturnStub;

class ReturnMgr
{
public:
    NTSTATUS Init(int p_iNumberOfStubs);
    NTSTATUS Shutdown();


    ReturnStub * pFindStub
    (
        ULONG p_ulReturnAddress
    );
protected:
    void CommonReturnPoint
    (
        PULONG pReturnAddress,
        PULONG pReturnValue
    );
    static void NakedReturnPoint(void);

    ReturnStub *    m_pReturnStubArray;
    int             m_iNumStubs;
};//class ReturnMgr

#pragma pack(pop)

#endif //_RETURN_H_
